package cidss.Destinations;

import java.util.Vector;

public class Destinations {

  public Vector destination;
  public String dst_logic;


  public Destinations() {
    destination = new Vector();
    dst_logic = null;
  }

  public boolean addDestination(String ip, boolean ip_neg, String mask, String port) {

    Destination d = new Destination();

    d.destination_ip = ip;
    d.destination_ip_mask = mask;
    d.destination_ip_neg = ip_neg;
    d.destination_port = port;

    destination.add(d);

    return true;
  }

  public String[] getDestinationArray() {
    String[] val = new String[4];
    val[0] = ""; val[1] = ""; val[2] = ""; val[3] = "";
    if (destination.size() == 0) {
      return val;
    }
    Destination d = (Destination)destination.get(0);
    val[0] = d.destination_ip;
    val[1] = d.destination_ip_mask;
    val[2] = "" + d.destination_ip_neg;
    val[3] = d.destination_port;
    return val;
  }

  public String getDescribe() {
    String s = "";
    Destination dst;

    for(int i=0; i<destination.size(); i++) {
      dst = (Destination)destination.get(i);
      s += "\nDestination["+i+"] IP: " + dst.destination_ip;
      s += "\nDestination["+i+"] IP negation: " + dst.destination_ip_neg;
      s += "\nDestination["+i+"] IP mask: " + dst.destination_ip_mask;
      s += "\nDestination["+i+"] port: " + dst.destination_port;
    }

    if (destination.size()>1) {
      s += "\nDestinations logic: ";
      if (dst_logic == null || dst_logic.equals("")) {
        for (int i = 0; i < destination.size() - 1; i++)
          s += i + " AND ";
        s += (destination.size() - 1);
      } else {
        s += dst_logic;
      }
    }
    return s;
  }

}
