package cidss.Sources;

import java.util.Vector;

public class Sources {

  public Vector source;
  public String src_logic;


  public Sources() {
    source = new Vector();
    src_logic = null;
  }

  public void addSource(Source s) {
    this.source.add(s);
  }

  public boolean addSource(String ip, boolean ip_neg, String mask, String port) {

    Source s = new Source();

    s.source_ip = ip;
    s.source_ip_mask = mask;
    s.source_ip_neg = ip_neg;
    s.source_port = port;

    source.add(s);

    return true;
  }

  public String[] getSourceArray() {
    String[] val = new String[4];
    val[0] = ""; val[1] = ""; val[2] = ""; val[3] = "";
    if (source.size() == 0) {
      return val;
    }
    Source s = (Source)source.get(0);
    val[0] = s.source_ip;
    val[1] = s.source_ip_mask;
    val[2] = "" + s.source_ip_neg;
    val[3] = s.source_port;
    return val;
  }

  public String getDescribe() {
    String s = "";
    Source src;

    for(int i=0; i<source.size(); i++) {
      src = (Source)source.get(i);
      s += "\nSource["+i+"] IP: " + src.source_ip;
      s += "\nSource["+i+"] IP negation: " + src.source_ip_neg;
      s += "\nSource["+i+"] IP mask: " + src.source_ip_mask;
      s += "\nSource["+i+"] port: " + src.source_port;
    }

    if (source.size()>1) {
      s += "\nSources logic: ";
      if (src_logic == null || src_logic.equals("")) {
        for (int i = 0; i < source.size() - 1; i++)
          s += i + " AND ";
        s += (source.size() - 1);
      } else {
        s += src_logic;
      }
    }
    return s;
  }

}
