package ids;

class AdapterNode {

    static final String[] typeName = {
        "none",
        "Element",
        "Attr",
        "Text",
        "CDATA",
        "EntityRef",
        "Entity",
        "ProcInstr",
        "Comment",
        "Document",
        "DocType",
        "DocFragment",
        "Notation",
    };

        org.w3c.dom.Node domNode;

        public AdapterNode(org.w3c.dom.Node node) {
            domNode = node;
/*
            org.w3c.dom.Node tmp = node.getFirstChild();
            if (node.getChildNodes().getLength() > 0) {
              while (tmp != null) {
                if (tmp.toString().startsWith("\n"))
                  domNode.removeChild(tmp);
                tmp = node.getNextSibling();
              }
            }
//            domNode = node;
            return;
*/
/*
            while ((tmp = node.getNextSibling()) != null) {
              String nv = tmp.getNodeValue();
              if (nv != null && nv.startsWith("\n")) {
                domNode.removeChild(tmp);
              }
            }
 */
        }

        public String toString() {
            String s = typeName[domNode.getNodeType()];
            String nodeName = domNode.getNodeName();
            String nodeValue = domNode.getNodeValue();
            org.w3c.dom.NamedNodeMap nodeAttr = domNode.getAttributes();
            if (nodeName.equals("Signature")) {
                nodeName += " " + nodeAttr.getNamedItem("sid").getNodeValue();
            }
            if (nodeName.equals("Protocol")) {
                nodeName += " " +
                    nodeAttr.getNamedItem("proto_id").getNodeValue()
                    + " " + nodeAttr.getNamedItem("Type").getNodeValue();
            }
            if (nodeName.equals("Source")) {
                nodeName += " " + nodeAttr.getNamedItem("src_id").getNodeValue();
            }
            if (nodeName.equals("Destination")) {
                nodeName += " " + nodeAttr.getNamedItem("dst_id").getNodeValue();
            }
            if (nodeName.equals("Pattern")) {
                nodeName += " " + nodeAttr.getNamedItem("pat_id").getNodeValue();
            }
            if (!nodeName.startsWith("#")) {
                s += ": " + nodeName;
            }
            if (nodeValue != null) {
              String t = nodeValue.trim();
              if (t.equals("")) {
                return s;
              }

              if (s.startsWith("ProcInstr"))
                s += ", ";
              else
                s += ": ";

              int x = t.indexOf("\n");
              if (x >= 0)
                t = t.substring(0, x);
              s += t;
            }
            return s;
        }

        /*
         * Return	children, index, and count values
         */
        public int index(AdapterNode child) {

            int count = childCount();
            for (int i = 0; i < count; i++) {
                AdapterNode n = this.child(i);
                if (child.domNode == n.domNode)
                    return i;
            }
            return -1;
        }

        public AdapterNode child(int searchIndex) {

            org.w3c.dom.Node node = domNode.getChildNodes().item(searchIndex);
            return new AdapterNode(node);
        }

        public int childCount() {
            return (domNode != null ? domNode.getChildNodes().getLength() : 0);
        }
    }

