package cidss.Protocols;

import cidss.Protocols.Protocol;
import java.util.Vector;

public class Protocols {

  public Vector protocol;
  public String proto_logic;

  public Protocols() {
    protocol = new Vector();
    proto_logic = null;
  }

  public boolean addProtocol(Protocol new_protocol){
    protocol.add(new_protocol);
    return true;
  }

  public String getProtocolType() {
    if (protocol.size() == 0) {
      return "";
    }
    Protocol p = (Protocol)protocol.get(0);
    return p.type;
  }

  public String getDescribe() {
    String s = "";
    Protocol proto;

    for(int i=0; i<protocol.size(); i++) {
      proto = (Protocol)protocol.get(i);
      s += "\nProtocol["+i+"] Type: " + proto.type;
      if (proto.tcp_ack != 0)
        s += "\nProtocol["+i+"] TCP_Ack: " + proto.tcp_ack;
      if (proto.tcp_state != null)
        s += "\nProtocol["+i+"] TCP_State: " + proto.tcp_state;
      if (proto.tcp_seq != 0)
        s += "\nProtocol["+i+"] TCP_Seq: " + proto.tcp_seq;
      if (proto.tcp_dsize != null)
        s += "\nProtocol["+i+"] TCP_Dsize: " + proto.tcp_dsize;
      if (proto.tcp_flags != null)
        s += "\nProtocol["+i+"] TCP_Flags: " + proto.tcp_flags;
      if (proto.tcp_window != 0)
        s += "\nProtocol["+i+"] TCP_Window: " + proto.tcp_window;
      if (proto.udp_dsize != null)
        s += "\nProtocol["+i+"] UDP_Dsize: " + proto.udp_dsize;
      if (proto.icmp_dsize != null)
        s += "\nProtocol["+i+"] ICMP_Dsize: " + proto.icmp_dsize;
      if (proto.icmp_icmp_id != 0)
        s += "\nProtocol["+i+"] ICMP_Icmp_Id: " + proto.icmp_icmp_id;
      if (proto.icmp_icmp_seq != 0)
        s += "\nProtocol["+i+"] ICMP_Icmp_Seq: " + proto.icmp_icmp_seq;
      if (proto.icmp_icode != null)
        s += "\nProtocol["+i+"] ICMP_Icode: " + proto.icmp_icode;
      if (proto.icmp_itype != null)
        s += "\nProtocol["+i+"] ICMP_Itype: " + proto.icmp_itype;
      if (proto.ip_ttl != null)
        s += "\nProtocol["+i+"] IP_Ttl: " + proto.ip_ttl;
      if (proto.ip_tos != 0)
        s += "\nProtocol["+i+"] IP_Tos: " + proto.ip_tos;
      if (proto.ip_fragbits != null)
        s += "\nProtocol["+i+"] IP_Fragbits: " + proto.ip_fragbits;
      if (proto.ip_id != 0)
        s += "\nProtocol["+i+"] IP_Id: " + proto.ip_id;
      if (proto.ip_ip_proto != null)
        s += "\nProtocol["+i+"] IP_Ip_proto: " + proto.ip_ip_proto;
      if (proto.ip_dsize != null)
        s += "\nProtocol["+i+"] IP_Dsize: " + proto.ip_dsize;
      if (proto.ip_ipopts != null)
        s += "\nProtocol["+i+"] IP_Ipopts: " + proto.ip_ipopts;
      if (proto.isdataat != null)
        s += "\nProtocol["+i+"] Isdataat: " + proto.isdataat;
      if (proto.rpc != null)
        s += "\nProtocol["+i+"] Rpc: " + proto.rpc;    }

    if (protocol.size() > 1) {
      s += "\nProtocols logic: ";
      if (proto_logic == null || proto_logic.equals("")) {
        for (int i = 0; i < protocol.size() - 1; i++)
          s += i + " AND ";
        s += (protocol.size() - 1);
      } else {
        s += proto_logic;
      }
    }
    return s;
  }


}
