package cidss.Session;

import java.util.Vector;

public class CaseStateInstructions {

/*
  public String Isset_Var[];
  public String Isset_Var_var[];
  public String Compare_Var[];
  public String Compare_Var_var[];
  public String Compare_Var_value[];
  public String Set_Var[];
  public String Set_Var_var[];
  public String Set_Var_value[];
  public String Unset_Var[];
  public String Unset_Var_var[];
*/
  public IssetVar IssetVar;
  public CompareVar CompareVar;
  public SetVar SetVar;
  public UnsetVar UnsetVar;

  public CaseStateInstructions() {
    IssetVar = new IssetVar();
    CompareVar = new CompareVar();
    SetVar = new SetVar();
    UnsetVar = new UnsetVar();
  }
}


class Set {
  public String name;
  public String value;
}
class IssetVar extends Set {
  public Vector isset;
  public IssetVar() {
    isset = new Vector();
  }
  public boolean add(String name) {
    this.name = name;
    isset.add(this);
    return true;
  }
}
class CompareVar extends Set {
  public Vector compare;
  public CompareVar() {
    compare = new Vector();
  }
  public boolean add(String name, String value) {
    this.name = name;
    this.value = value;
    compare.add(this);
    return true;
  }
}
class SetVar extends Set {
  public Vector set;
  public SetVar() {
    set = new Vector();
  }
  public boolean add(String name, String value) {
    this.name = name;
    this.value = value;
    set.add(this);
    return true;
  }
}
class UnsetVar extends Set {
  public Vector unset;
  public UnsetVar() {
    unset = new Vector();
  }
  public boolean add(String name) {
    this.name = name;
    unset.add(this);
    return true;
  }
}
